/*
 * Copyright Openmind http://www.openmindonline.it
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package it.openutils.spring.email;

import java.io.File;
import java.util.List;
import java.util.Map;


/**
 * @author fgiust
 * @version $Id: TemplatedMailSender.java 527 2008-01-14 12:01:09Z fgiust $
 */
public interface TemplatedMailSender
{

    /**
     * Compiles the freemarker template with the model data and send it to the given addresses, adding a cc to the given
     * addresses.
     * @param templateFile Freemarker template file name
     * @param model Map merged into template
     * @param from Mail that will result as sender of the compiled mail.
     * @param to mail to list
     * @param cc mail cc list
     * @param replyto TODO
     * @param async send mail asynchrounisly (if allowed in configuration)
     * @param attachments list of attachments
     */
    void prepareAndSendMail(final String templateFile, final Map<String, Object> model, final String from,
        final String[] to, final String[] cc, final String[] bcc, String replyto, boolean async, List<File> attachments);

}
